﻿using Syncfusion.DocIO.DLS;
using Syncfusion.DocToPDFConverter;
using Syncfusion.OfficeChartToImageConverter;
using Syncfusion.Pdf;
using System.IO;
using System.Web;
using System.Web.Http;

namespace DocIO_AspNetWebApi_ServiceApplication.Controllers
{
    public class WordToPDFController : ApiController
    {
        [AcceptVerbs("Post")]
        /// <summary>
        /// Converts the Word document to PDF document.
        /// </summary>
        public void ConvertToPDF()
        {
            string filePath = HttpContext.Current.Server.MapPath("App_Data").Replace("\\api\\WordToPDF","") + "\\Template.doc";
            //Loads an existing Word document stream
            using (WordDocument wordDocument = new WordDocument(filePath))
            {
                //Performs the mail merge with field names and values.
                string[] fieldNames = new string[] { "Emp_Id", "Name", "Phone", "City" };
                string[] fieldValues = new string[] { "1001", "Peter", "+122-2222222", "London" };
                wordDocument.MailMerge.Execute(fieldNames, fieldValues);
                //Initializes the ChartToImageConverter for converting charts during Word to pdf conversion
                wordDocument.ChartToImageConverter = new ChartToImageConverter();
                wordDocument.ChartToImageConverter.ScalingMode = Syncfusion.OfficeChart.ScalingMode.Normal;
                //Creates an instance of the DocToPDFConverter
                using (DocToPDFConverter docToPDFConverter = new DocToPDFConverter())
                {
                    //Converts Word document into PDF document
                    using (PdfDocument pdfDocument = docToPDFConverter.ConvertToPDF(wordDocument))
                    {
                        //Saves the PDF document to response stream
                        pdfDocument.Save("WordToPDF.pdf", HttpContext.Current.Response, HttpReadType.Save);
                        pdfDocument.Close(true);
                    }
                }
            }
        }
    }
}
